#pragma once
#include "dxa.h"

namespace Dxa {
	class Triangle :
		public Dxa::Base
	{
		#pragma region 2.5
		ID3D11Buffer* vertexBuffer;
		ID3D11InputLayout* inputLayout;
		ID3D11VertexShader* vertexShader;
		ID3D11PixelShader* pixelShader;
		#pragma endregion resource, inputlayout, shader pointers
		#pragma region 2.0
	public:
		Triangle(ID3D11Device* device);
		HRESULT createResources();
		HRESULT releaseResources();
		void render(ID3D11DeviceContext* context);
		#pragma endregion overridden event handlers
	};

}