#pragma once
#include "dxa.h"
#pragma region 4.2
#include "d3dx11effect.h"
#pragma endregion effect framework include

namespace Dxa {
	class TriangleWithFx :
		public Dxa::Base
	{
		#pragma region 2.5
		ID3D11Buffer* vertexBuffer;
		ID3D11InputLayout* inputLayout;
		#pragma endregion resource, inputlayout pointers
		#pragma region 4.3
		ID3DX11Effect* effect;
		#pragma endregion effect instance pointer
		#pragma region 2.0
	public:
		TriangleWithFx(ID3D11Device* device);
		HRESULT createResources();
		HRESULT releaseResources();
		void render(ID3D11DeviceContext* context);
		#pragma endregion overridden event handlers
	};

}